EDBFrame = CreateFrame("Frame", "EDBFrame")
local playername=(UnitName("PLAYER"));

EDB = {};
function EDBEvent(self, event, ...)
	if (event=="ADDON_LOADED") then
		local addon = ...;
		if (addon=="Blizzard_GuildUI") then
			EDB_CreateFrame();
			GuildRosterContainer:HookScript("OnUpdate", function() EDB_GuildFrameUpdated() end);
			EDBFrame:UnregisterEvent("ADDON_LOADED");
		end
	end
end

EDBFrame:SetScript("OnEvent", EDBEvent);
EDBFrame:RegisterEvent("ADDON_LOADED");
EDBFrame:RegisterEvent("CHAT_MSG_ADDON");

function EDB_CreateFrame()
	if (GuildMemberDetailFrame) then
		EDBFrame:SetParent(GuildMemberDetailFrame);
		EDBFrame:SetWidth(GuildMemberDetailFrame:GetWidth());
		EDBFrame:SetHeight(55);
		EDBFrame:SetPoint("TOPLEFT", GuildMemberDetailFrame, "BOTTOMLEFT", 0, 5);
		EDBFrame:SetBackdrop(GuildMemberDetailFrame:GetBackdrop());
		
		EDBMSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBMSText:SetHeight(10);
		EDBMSText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 15, -15);
		EDBMSButton = CreateFrame("Button", nil, EDBFrame)
		EDBMSButton:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 15, -15);
		EDBMSButton:SetWidth(100)
		EDBMSButton:SetHeight(10);
		EDBMSButton:SetScript("OnClick", Elgoh_CycleMS);

		EDBOSText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBOSText:SetHeight(10);
		EDBOSText:SetPoint("TOPLEFT", EDBMSText, "BOTTOMLEFT", 0, -5);
		EDBOSButton = CreateFrame("Button", nil, EDBFrame)
		EDBOSButton:SetPoint("TOPLEFT", EDBMSText, "BOTTOMLEFT", 0, -5);
		EDBOSButton:SetWidth(100)
		EDBOSButton:SetHeight(10)
		EDBOSButton:SetScript("OnClick", Elgoh_CycleOS);
		
		EDBDKPText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBDKPText:SetHeight(10);
		EDBDKPText:SetJustifyH("RIGHT");
		EDBDKPText:SetPoint("TOPLEFT", EDBFrame, "TOPLEFT", 0, -15);
		EDBDKPText:SetPoint("TOPRIGHT", EDBFrame, "TOPRIGHT", -10, -15);
		
		EDBThreshText = EDBFrame:CreateFontString("EDBLabel", "ARTWORK", "GameFontNormal");
		EDBThreshText:SetHeight(10);
		EDBThreshText:SetJustifyH("RIGHT");
		EDBThreshText:SetPoint("TOPLEFT", EDBDKPText, "BOTTOMLEFT", 0, -5);
		EDBThreshText:SetPoint("TOPRIGHT", EDBFrame, "TOPRIGHT", -10, -35);
		
		if(CanEditOfficerNote()==1) then
			EDBEPGPFrame = CreateFrame("Frame", "EDBEPGPFrame")
			EDBEPGPFrame:SetParent(GuildMemberDetailFrame);
			EDBEPGPFrame:SetWidth(GuildMemberDetailFrame:GetWidth());
			EDBEPGPFrame:SetHeight(55);
			EDBEPGPFrame:SetPoint("TOPLEFT", EDBFrame, "BOTTOMLEFT", 0, 5);
			EDBEPGPFrame:SetBackdrop(GuildMemberDetailFrame:GetBackdrop());
			
			EDBAmountBox = CreateFrame("EditBox", nil, EDBEPGPFrame, "InputBoxTemplate")
			EDBAmountBox:SetWidth(60)
			EDBAmountBox:SetHeight(20)
			EDBAmountBox:SetPoint("LEFT", EDBEPGPFrame, "LEFT", 15,0);
			EDBAmountBox:SetAutoFocus(false)
			EDBAmountBox:SetJustifyH("LEFT");
			EDBAmountBox:SetScript("OnEnterPressed", function() EDBAmountBox:ClearFocus(); end)
			
			EDBAwardEP = CreateFrame("Button", nil, EDBEPGPFrame, "UIPanelButtonTemplate");
			EDBAwardEP:SetWidth(40);
			EDBAwardEP:SetHeight(40);
			EDBAwardEP:SetText("EP");
			EDBAwardEP:SetPoint("LEFT", EDBAmountBox, "RIGHT", 5,0);
			EDBAwardEP:SetScript("OnClick", function() EDB_GrantEP(tonumber(EDBAmountBox:GetText()), EDB.selected); end);
			
			EDBAwardGP = CreateFrame("Button", nil, EDBEPGPFrame, "UIPanelButtonTemplate");
			EDBAwardGP:SetWidth(40);
			EDBAwardGP:SetHeight(40);
			EDBAwardGP:SetText("GP");
			EDBAwardGP:SetPoint("LEFT", EDBAwardEP, "RIGHT", 5,0);
			EDBAwardGP:SetScript("OnClick", function() EDB_GrantGP(tonumber(EDBAmountBox:GetText()), EDB.selected); end)
		end
		
		EDB_MakeTooltips();
	end
end

function Elgoh_CycleMS()
	EDB[EDB.selected]["MS"]=EDB[EDB.selected]["MS"]-1;
	if(EDB[EDB.selected]["MS"]<=0) then EDB[EDB.selected]["MS"]=3; end
	EDB_UpdateLines(EDB.selected);
	EDB_ToNote(EDB.selected);
end

function Elgoh_CycleOS()
	EDB[EDB.selected]["OS"]=EDB[EDB.selected]["OS"]-1;
	if(EDB[EDB.selected]["OS"]==0) then EDB[EDB.selected]["OS"]=3; end
	EDB_UpdateLines(EDB.selected);
	EDB_ToNote(EDB.selected);
end

function EDB_GuildFrameUpdated(ow)
	local pname= GetGuildRosterInfo(GetGuildRosterSelection());
	if pname then
		if((pname == EDB.selected) or ow) then return end
		EDB.selected = pname;
		EDB_Snapshot(pname);
		EDB_Snapshot(UnitName("PLAYER"));
		EDB_UpdateLines(pname);
	end
end

local Roles={"Tank","Healer","DPS"};
function EDB_UpdateLines(who)
	EDBDKPText:SetText("");
	local MSText="";
	local OSText="";
	local EPGPThreshhold=ElgohSettings["EPGPThreshhold"];
	if(EDB[who]) then
		MSText=Roles[EDB[who]["MS"]];
		OSText=Roles[EDB[who]["OS"]];
		EDBMSText:SetText("MS: "..MSText);
		EDBOSText:SetText("OS: "..OSText);
		--- DKP bit
		if(who~=playername) then
			if(EDB[playername] and EDB[playername]["priority"]~=nil) then
				if(EDB[who]["priority"]) then
					EDBDKPText:SetText("DKP: "..EDB[who]["priority"]);
					EDBDKPText:SetTextColor(0.2,1,0.2);
					if((EDB[playername]["earned"]>EPGPThreshhold and EDB[who]["earned"]>EPGPThreshhold) or (EDB[playername]["earned"]<EPGPThreshhold and EDB[who]["earned"]<EPGPThreshhold)) then
						if(EDB[who]["priority"]>EDB[playername]["priority"]) then
							EDBDKPText:SetText("DKP: "..EDB[who]["priority"]);
							EDBDKPText:SetTextColor(1,0.2,0.2);
						end
					elseif(EDB[playername]["earned"]<EPGPThreshhold and EDB[who]["earned"]>EPGPThreshhold) then
						EDBDKPText:SetText("DKP: "..EDB[who]["priority"]);
						EDBDKPText:SetTextColor(1,0.2,0.2);
					end
				end
			end
		else
			EDBDKPText:SetText("DKP: "..EDB[playername]["priority"]);
			EDBDKPText:SetTextColor(1,1,1);			
		end
		if(EDB[who]["earned"]>EPGPThreshhold) then EDBThreshText:SetText("Above "..EPGPThreshhold); else EDBThreshText:SetText("Below "..EPGPThreshhold); end
	end
end

function EDB_LoadValues(who)
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);
		if(who==nil or name==who) then
			if(GL_DKPValues["current_dkp_data"][name:lower()]~=nil) then
				EDB[name]["earned"]=GL_DKPValues["current_dkp_data"][name:lower()]["earned"];
				EDB[name]["spent"]=GL_DKPValues["current_dkp_data"][name:lower()]["spent"];
				EDB[name]["priority"]=GL_DKPValues["current_dkp_data"][name:lower()]["current"];
			end
		end
	end
end

function EDB_ToNote(who)
	for i = 1, GetNumGuildMembers(), 1 do 
		local name = GetGuildRosterInfo(i);
		if(who==nil or name==who) then
		if(EDB[who].earned~=0) then
			if(EDB[who].spent~=0) then
				EDB[who].priority=(floor(((EDB[who].earned/EDB[who].spent)*100) + 0.5 )) /100;
			else
				EDB[who].priority=EDB[who].earned;
			end
		end
			local oNote=strjoin(":","$"..EDB[name]["MS"], EDB[name]["OS"], EDB[name]["earned"], EDB[name]["spent"], EDB[name]["priority"].."$");
			GuildRosterSetOfficerNote(i, oNote);
		end
	end
end

function EDB_Snapshot(who)
--EDebug("Snapshotting "..who);
	for i = 1, GetNumGuildMembers(), 1 do
		local name,_,_,_,_,_,_,officernote = GetGuildRosterInfo(i);
		if(name==who) then
			local EDBString=string.match(officernote, "$(.*)%$");
			if(EDBString==nil) then Elgoh_Print("Invalid DKP String found: Defaulting "..who); Elgoh_Default(who); return; end
			
			local MS,OS,Earned,Spent,Priority=strsplit(":",EDBString);
			MS=tonumber(MS);
			OS=tonumber(OS);
			Earned=tonumber(Earned);
			Spent=tonumber(Spent);
			Priority=tonumber(Priority);
			
			if(MS~=1 and MS~=2 and MS~=3) then Elgoh_Print("Invalid DKP String found: Defaulting "..who); Elgoh_Default(who); return; end
			if(Earned==nil or Spent==nil or Priority==nil) then Elgoh_Print("Invalid DKP String found: Defaulting "..who); Elgoh_Default(who); return; end
			
			EDB[who]={};
			EDB[who]["MS"]=MS;
			EDB[who]["OS"]=OS;
			EDB[who]["earned"]=Earned;
			EDB[who]["spent"]=Spent;
			EDB[who]["priority"]=Priority;
			return;
		end
	end
end

function EDB_GrantEP(amount, who, mass)
--if(amount~=math.abs(amount)) then amount="-"..amount; else amount="+"..amount; end
	if mass then
		for i=1,#who do
			EDB_Snapshot(who[i]);
			EDB[who[i]]["earned"]=EDB[who[i]]["earned"]+amount;
			EDB_ToNote(who[i]);
		end
		SendChatMessage(#who.." peoples EP has been changed by "..amount, "OFFICER")
	--	Elgoh_Print(#who.." peoples EP has been boosted by "..amount);
	else
		EDB_Snapshot(who);
		EDB[who]["earned"]=EDB[who]["earned"]+amount;
		-- EDB[who].priority=string.format("%.0f", (EDB[who].earned/EDB[who].spent));
		EDB_ToNote(who);
		SendChatMessage(who.."'s EP has been changed by "..amount.." to "..EDB[who]["earned"], "OFFICER")
		EDB_UpdateLines(EDB.selected);
	end
end

function EDB_GrantGP(amount, who, mass)
--if(amount~=math.abs(amount)) then amount="-"..amount; else amount="+"..amount; end
	if mass then
		for i=1,#who do
			EDB_Snapshot(who[i]);
			EDB[who[i]]["spent"]=EDB[who[i]]["spent"]+amount;
			EDB_ToNote(who[i]);
		end
		SendChatMessage(#who.." peoples GP has been changed by "..amount, "OFFICER")
	else
		EDB_Snapshot(who);
		EDB[who]["spent"]=EDB[who]["spent"]+amount;
		EDB_ToNote(who);
		SendChatMessage(who.."'s GP has been changed by "..amount.." to "..EDB[who]["spent"], "OFFICER")
		EDB_UpdateLines(EDB.selected);
	end
end

function Elgoh_Default(who)
	EDB[who]={};
	EDB[who]["MS"]=3;
	EDB[who]["OS"]=3;
	EDB[who]["earned"]=0;
	EDB[who]["spent"]=0;
	EDB[who]["priority"]=0;
	EDB_LoadValues(who);
	EDB_ToNote(who);
end