ElgohLootButton={};
local height=_G["LootButton1"]:GetHeight();
for i=1, 4 do
	local name="ElgohLootButton"..i.."MS";
	ElgohLootButton[i]=CreateFrame("Button",name,_G["LootFrame"],"UIPanelButtonTemplate")
	ElgohLootButton[i]:SetWidth(height)
	ElgohLootButton[i]:SetHeight(height)
	local button=_G["LootButton"..i];
	ElgohLootButton[i]:SetPoint("TOP", button, "TOP", 0, 0);
	ElgohLootButton[i]:SetPoint("LEFT", _G["LootFrame"], "RIGHT", -65, 0);
	ElgohLootButton[i]:SetScript("OnClick", function(self) Elgoh_LootButton(self); end);
	
	local name="ElgohLootButton"..i.."OS";
	ElgohLootButton[i+4]=CreateFrame("Button",name,_G["LootFrame"],"UIPanelButtonTemplate")
	ElgohLootButton[i+4]:SetWidth(height)
	ElgohLootButton[i+4]:SetHeight(height)
	ElgohLootButton[i+4]:SetPoint("TOP", button, "TOP", 0, 0);
	ElgohLootButton[i+4]:SetPoint("LEFT", _G["ElgohLootButton"..i.."MS"], "RIGHT", 5, 0);
	ElgohLootButton[i+4]:SetScript("OnClick", function(self) Elgoh_LootButton(self); end);
	
	ElgohLootButton[i]:SetText("MS");
	ElgohLootButton[i+4]:SetText("OS");
	
	ElgohLootButton[i]:Hide();
	ElgohLootButton[i+4]:Hide();
end

ElgohLootButtonLink=CreateFrame("Button",nil,_G["LootFrame"],"UIPanelButtonTemplate")
ElgohLootButtonLink:SetWidth(100)
ElgohLootButtonLink:SetHeight(25)
ElgohLootButtonLink:SetPoint("TOP", _G["LootFrame"], "TOP", 0, -40);
ElgohLootButtonLink:SetPoint("LEFT", _G["LootFrame"], "LEFT", 75, 0);
ElgohLootButtonLink:SetScript("OnClick", function() Elgoh_LootShow(1); end);
ElgohLootButtonLink:SetText("Link");
ElgohLootButtonLink:Hide();

function Elgoh_LootButton(self)
	local item=string.sub(self:GetName(), 16,16);
	local spec=string.sub(self:GetName(), 17,18);
	local itemLink=GetLootSlotLink(item);
	if itemLink==nil then return; end
	local message;
	if(spec=="MS") then
		message=string.gsub(ElgohSettings["MSString"], "ITEM", itemLink)
	elseif(spec=="OS") then
		message=string.gsub(ElgohSettings["OSString"], "ITEM", itemLink)
	end
	EDebug(message);
	SendChatMessage(message, "RAID_WARNING");
	LootingReset();
	Elgoh_RefreshLootList();
	ElgohRolling=1;
end

local winner="";
function Elgoh_RaiderInterested(name)
	if(ElgohRolling==0) then return; end
	for i=1,#InterestedRaiders do
		if(InterestedRaiders[i]==name) then return; end
	end
	EDB_Snapshot(name);
	tinsert(InterestedRaiders, name);
	local oldWinner=winner;
	Elgoh_RefreshLootList();
	winner=InterestedRaiders[1];
	if(winner==oldWinner) then 
		SendChatMessage(winner.." is still winning with EP/GP: "..EDB[winner].priority, "RAID"); 
		--EDebug(oldWinner.." "..winner.." is still winning with "..EDB[winner].priority);
	else 
		SendChatMessage(winner.." is our current winner with EP/GP: "..EDB[winner].priority, "RAID");
		--EDebug(oldWinner.." "..winner.." is our current winner with "..EDB[winner].priority);
	end
end

function LootingReset()
	InterestedRaiders={};
	ElgohRolling=0;
	winner="";
	if(ElgohLootFrame~=nil) then ElgohLootFrame:Hide(); end
end

function Elgoh_RefreshLootList()
	if(ElgohLootFrame==nil) then
		ElgohLootFrame=CreateFrame("Frame","ElgohLootFrame")
		ElgohLootFrame:SetHeight(100)
		ElgohLootFrame:SetBackdrop({bgFile = "Interface/DialogFrame/UI-DialogBox-Background-Dark", 
                                            edgeFile = "Interface/DialogFrame/UI-DialogBox-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
		ElgohLootFrame:SetBackdropColor(0,0,0,1);
		
		ElgohLootFrame:SetPoint("TOP", _G["LootFrame"], "BOTTOM" ,-25,10);
		ElgohLootFrame:SetWidth(150);
		
		ELFButton = CreateFrame("Button",nil,ElgohLootFrame,"UIPanelButtonTemplate")
		ELFButton:SetPoint("BOTTOM", ElgohLootFrame, "BOTTOM", 0,-10)
		ELFButton:SetWidth(80)
		ELFButton:SetHeight(22)
		ELFButton:SetText("Finish");
		ELFButton:SetScript("OnClick", LootingReset);
	end
	table.sort(InterestedRaiders, Elgoh_SortLooters);	
	if(#InterestedRaiders>0) then ElgohLootFrame:Show(); else ElgohLootFrame:Hide(); end
	for i=1, 5 do
		if(ElgohLooters[i]==nil) then
			ElgohLooters[i] = ElgohLootFrame:CreateFontString(nil, "ARTWORK", "GameFontNormal");
			ElgohLooters[i]:SetHeight(10);
			ElgohLooters[i]:SetPoint("TOPLEFT", ElgohLootFrame, "TOPLEFT", 10, 5-(15*i));
			ElgohLooters[i]:Hide();
		end
		if(InterestedRaiders[i]~=nil) then
			ElgohLooters[i]:SetText(i..") "..InterestedRaiders[i]);
			ElgohLooters[i]:Show();
		else ElgohLooters[i]:Hide(); end
	end
end

function Elgoh_SortLooters(a,b)
	EDB_Snapshot(a);
	EDB_Snapshot(b);
	local EPGPT=ElgohSettings["EPGPThreshhold"];
	if((EDB[a]["earned"]>EPGPT and EDB[b]["earned"]>EPGPT) or (EDB[a]["earned"]<EPGPT and EDB[b]["earned"]<EPGPT)) then
		--EDebug("Both above");
		return EDB[a]["priority"]>EDB[b]["priority"];
	elseif(EDB[a]["earned"]>EPGPT and EDB[b]["earned"]<EPGPT) then
		--EDebug("A was above and B wasn't");
		return true;
	elseif(EDB[a]["earned"]<EPGPT and EDB[b]["earned"]>EPGPT) then
		--EDebug("B was above and A wasn't");
		return false;
	end
end

function Elgoh_LootShow(link)
	local Loot={};
	local epics=0;
	local header=0;
	for i=1,GetNumLootItems() do
		local _,lootName,_,rarity = GetLootSlotInfo(i);
		if(LootSlotIsItem(i) and (rarity>=4 or (rarity>=1 and ElgohSettings["Debug"]==1))) then
			if(link==1 and header==0) then SendChatMessage("Linking loot for "..UnitName("TARGET"), "RAID"); header=1; end
			epics=epics+1;
			if(link==1) then 
				if(GetNumRaidMembers()>0) then SendChatMessage(epics..": "..GetLootSlotLink(i), "RAID"); else SendChatMessage(epics..": "..GetLootSlotLink(i), "SAY"); end
			end
		end 
	end
	if(link==1) then return; end
	if(epics>0) then ElgohLootButtonLink:Show(); else ElgohLootButtonLink:Hide(); end
	if(LootFrame.page==nil) then LootFrame.page=1; end
	for i=1,4 do
		local _,_,_,rarity = GetLootSlotInfo(i+(4*(LootFrame.page-1)));
		if(LootSlotIsItem(i+(4*(LootFrame.page-1))) and (rarity>=4 or (rarity>=1 and ElgohSettings["Debug"]==1))) then
			ElgohLootButton[i]:Show();
			ElgohLootButton[i+4]:Show();
		else
			ElgohLootButton[i]:Hide();
			ElgohLootButton[i+4]:Hide();
		end
	end
end