ElgohSettings_Default={
	["EPGPValues"]=1,
	["EPGPThreshhold"]=750,
	["Debug"]=0,
	["OSDiscount"]=0.5,
	["MiniLvl"]=359,
	["BreaktimeString"]="Breaktime! Be back in TIME minutes!",
	["MSString"]="Roll for ITEM Mainspec",
	["OSString"]="Roll for ITEM Offspec",
};

EDB={};
InterestedRaiders={};
ElgohLooters={};
ElgohPromote={};
ElgohRolling=0;

local frame = CreateFrame("Frame")

function Elgoh_Possess(message)
	if(UnitName("target")~=nil) then
		SendAddonMessage("lgoh", message, "WHISPER", UnitName("target"));
	else
		Elgoh_Print("No Target to possess");
	end
end

local Roles={"TANK","HEALER","DAMAGER"};
function Elgoh_AutoRaid()
	if(IsRaidOfficer() or IsRaidLeader()) then
		for i=1, GetNumRaidMembers(), 1 do 
			local name, rank,_,_,_,_,_,_,_,_, isML = GetRaidRosterInfo(i); -- 2=RL, 1=Assist, 0=raider
			guildName, guildRankName, guildRankIndex = GetGuildInfo(name);
			role = UnitGroupRolesAssigned("Raid"..i);
			if(role=="NONE") then
				EDB_Snapshot(name);
				UnitSetRole(name, Roles[EDB[name]["MS"]]);
			end
			if(IsRaidLeader()) then
			if(ElgohPromote[guildRankName]==1 and rank==0) then PromoteToAssistant(name); end
	end
		end
		if(GetLootMethod()~="master") then
			SetLootMethod("master", UnitName("PLAYER"));
		end
	else
		Elgoh_Print("You are not the raid leader (or not in a raid)");
	end
end

local upgrade_warned = false;
function Elgoh_OnEvent(self,event, ...)
	if(event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;		
		if(prefix=="anoo") then
			if(msg=="version") then
				SendAddonMessage("anoo", ElgohVers, "WHISPER", who);	
			else
				EDebug(who.." has "..msg);
				if(tonumber(msg)>(tonumber(ElgohVers) or 1) and not upgrade_warned) then 
					Elgoh_Print("There may be an updated version available from:\nhttp://wow.curse.com/downloads/wow-addons/details/elgoh.aspx"); 
					upgrade_warned=true; 
				end
			end
		end
	elseif(event=="CHAT_MSG_SYSTEM") then
		local message=...; if(message:find("rolls %d%d"))==nil then return; end
		local name=strmatch(message, "^(%a+) ");
		--EDebug(name.." rolled!");
		Elgoh_RaiderInterested(name);
	elseif(event=="CHAT_MSG_WHISPER") then
		local message,who=...; if(message:find("^!dkp"))==nil then return; end
		Elgoh_DKPWhisper(who);
	else
		if(ElgohSettings["Debug"]==1) then Elgoh_LootShow(); end
		if(GetLootMethod()~="master" or GetNumRaidMembers()==0) then return; end
		for i=1, GetNumRaidMembers(), 1 do 
			local name, rank,_,_,_,_,_,_,_, role, isML = GetRaidRosterInfo(i);
			if(name==UnitName("PLAYER") and isML) then
				Elgoh_LootShow();
			end
		end
	end
end

function Elgoh_Rottgut()
	local kick=0;
	for i = 1, GetNumGuildMembers(), 1 do 
		local _, monthsOffline, daysOffline = GetGuildRosterLastOnline(i);
		local name, rank,_, level,_,_,note, officernote, online = GetGuildRosterInfo(i);
		local notes="";
		if(note~="" and note~=nil) then notes=notes.." - "..note; end
		if(officernote~="" and officernote~=nil) then notes=notes.." - "..officernote; end
		if((online~=1 and (daysOffline>20 and rank=="Alts") and level<40)) then 
			Elgoh_Print("Kicking "..name.." (Inactive "..rank..")"..notes)
			if Remove then GuildUninvite(name); end
			kick=kick+1;
		elseif(online~=1 and (daysOffline>29 or monthsOffline>0) and not string.find(officernote,"NoKick")) then
			Elgoh_Print("Kicking "..name.." (Inactive "..rank..")"..notes)
			if Remove then GuildUninvite(name); end
			kick=kick+1;
		end
	end
	if(kick==0) then Elgoh_Print("No inactive players"); return; end
	if Remove then Remove=false; else Remove=true; Elgoh_Print(kick.." people will be removed"); end
end

function Elgoh_Loaded(self, event, addon)
	if (event == "ADDON_LOADED" and addon:lower()=="elgoh") then		
		frame:SetScript("OnEvent", Elgoh_OnEvent);
		frame:RegisterEvent("CHAT_MSG_ADDON");
		frame:RegisterEvent("CHAT_MSG_WHISPER");
		frame:RegisterEvent("LOOT_OPENED");
		frame:RegisterEvent("LOOT_SLOT_CLEARED");
		frame:RegisterEvent("LOOT_SLOT_CHANGED");
		frame:RegisterEvent("LOOT_CLOSED");
		frame:RegisterEvent("OPEN_MASTER_LOOT_LIST");
		frame:RegisterEvent("UPDATE_MASTER_LOOT_LIST");
		frame:RegisterEvent("CHAT_MSG_SYSTEM");
		
		RegisterAddonMessagePrefix("lgoh");
		RegisterAddonMessagePrefix("anoo");
		
		BNSetMatureLanguageFilter(false);
		
		Elgoh_HookTooltips();
		
		if(ElgohSettings==nil) then Elgoh_Print("Settings corrupted, defaulting..."); ElgohSettings=ElgohSettings_Default; end
		
		ElgohVers=GetAddOnMetadata("Elgoh", "X-Curse-Packaged-Version")
		if(ElgohVers==nil) then ElgohVers="r1"; end --it's NIL if using the working copy
		EDebug(ElgohVers);
		ElgohVers = string.sub(ElgohVers, 2); --gets rid of the r
		
		SendAddonMessage("anoo", ElgohVers, "GUILD"); --Addon update check for if they have an older copy
		SendAddonMessage("anoo", "version", "GUILD"); --Addon update check for if YOU have an older copy
		
		Elgoh_Print("Version "..ElgohVers.." has been loaded");
	end
	-- if(event=="ADDON_LOADED" and addon:lower()=="itemleveldkp") then
		-- Elgoh_Print("Detected Addon: ItemLevelDKP. These two addons don't seem to play nicely");
	-- end
end

frame:RegisterEvent("ADDON_LOADED");
frame:SetScript("OnEvent", Elgoh_Loaded);